--------------------------------------------------------
-- Archivo creado  - viernes-junio-08-2012   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Function CLIENTSCOMPTADORALTADISP
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "CLIENTSCOMPTADORALTADISP" 

RETURN taulaClientComptador
IS
   functionReturn  taulaClientComptador :=taulaClientComptador();

   wclient      VARCHAR2(12);
   wcomptador    VARCHAR2(12);
   wmodel        VARCHAR2(12);
   n             INTEGER := 0;
     
   cursor cursorClients is
            SELECT cli.codi, con.codi, mcom.codi 
            FROM client cli, contracte con, comptador com, modelcmpt mcom
            WHERE cli.codi = con.client
            AND con.comptador = com.codi
            AND com.idmodel = mcom.codi
            AND datafi IS NULL
            AND com.codi IN (
                SELECT C.codi
                FROM COMPTADOR C, COMPTADOR_CENTRALDISTR C_CD,
                     CENTRALPROD_CENTRALDISTR CP_CD, 
                     CENTRAL_DISTR CD, CENTRAL_PROD CP
                WHERE C.codi = C_CD.comptador 
                 AND C_CD.activat = 'S'   
                 AND C_CD.centraldistr = CP_CD.centraldistr
                 AND CP_CD.centralprod = CP.codi
                 AND CP_CD.centraldistr = CD.codi
                 GROUP BY c.codi
                 HAVING COUNT (c.codi) > 1)
            ORDER BY cli.codi; 

BEGIN
  
	OPEN cursorClients;
      
      LOOP 
               FETCH cursorClients
                INTO wclient,
                     wcomptador,
                     wmodel;

               EXIT WHEN cursorClients%NOTFOUND;
               
               functionReturn.extend;
               n := n + 1;
               functionReturn(n) := filaClientComptador(wclient, wcomptador, wmodel);
      END LOOP;

	CLOSE cursorClients;

  RETURN functionReturn;
                                                    
END;

/

/
--------------------------------------------------------
--  DDL for Function CONSUMCENTRALPERPERIODE
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "CONSUMCENTRALPERPERIODE" (wcentralProd VARCHAR2, wdatainici DATE, wdatafi DATE)
RETURN taulaConsumCentralPeriode
IS
   functionReturn  taulaConsumCentralPeriode :=taulaConsumCentralPeriode();

   wconsum       NUMBER;
   wenergia      NUMBER;
   n             INTEGER := 0;
  
   cursor cursorCentralPeriode is
              SELECT SUM(CONSUM) FROM LECTURA
              WHERE TO_CHAR(DATALECTURA, 'DD/MM/YYYY') >= wdatainici
              AND TO_CHAR(DATALECTURA, 'DD/MM/YYYY') <= wdatafi
              AND CENTRALPROD = wcentralprod;
        
BEGIN
  
	OPEN cursorCentralPeriode;
         
      LOOP 
               FETCH cursorCentralPeriode
                INTO wconsum;

               EXIT WHEN cursorCentralPeriode%NOTFOUND;
               functionReturn.extend;
               n := n + 1;
               functionReturn(n) := filaConsumCentralPeriode(wCentralProd, wdatainici, wdatafi, wconsum, wconsum);

      END LOOP;

	   CLOSE cursorCentralPeriode;

  RETURN functionReturn;
                                                        

END;

/

/
--------------------------------------------------------
--  DDL for Function CONSUMCENTRALPROD
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "CONSUMCENTRALPROD" 	 (wcentralProd VARCHAR2, wany NUMBER)
RETURN taulaConsumCentralProd
IS
   functionReturn  taulaConsumCentralProd :=taulaConsumCentralProd();
 
   wconsum       NUMBER;
   n             INTEGER := 0;
  
   cursor cursorCentralProd is
              SELECT consum
                FROM HCENTRAL_PROD
               WHERE codi = NLS_UPPER(TRIM(wCentralProd))
               AND   anyconsum  = wany;

BEGIN
  
	OPEN cursorCentralProd;
         
      LOOP 
               FETCH cursorCentralProd
                INTO wconsum;

               EXIT WHEN cursorCentralProd%NOTFOUND;
               functionReturn.extend;
               n := n + 1;
               functionReturn(n) := filaConsumCentralProd(wCentralProd, wany, wconsum);
             
      END LOOP;

	   CLOSE cursorCentralProd;

  RETURN functionReturn;
                                                        

END;

/

/
--------------------------------------------------------
--  DDL for Function CONSUMCENTRALPRODANY
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "CONSUMCENTRALPRODANY" 	 (wcentralProd VARCHAR2, wany NUMBER)
RETURN taulaConsumCentralProd
IS
   functionReturn  taulaConsumCentralProd :=taulaConsumCentralProd();
 
   wconsum       NUMBER;
   n             INTEGER := 0;
  
   cursor cursorCentralProd is
              SELECT consum
                FROM HCENTRAL_PROD
               WHERE codi = NLS_UPPER(TRIM(wCentralProd))
               AND   anyconsum  = wany;

BEGIN
  
	OPEN cursorCentralProd;
         
      LOOP 
               FETCH cursorCentralProd
                INTO wconsum;

               EXIT WHEN cursorCentralProd%NOTFOUND;
               functionReturn.extend;
               n := n + 1;
               functionReturn(n) := filaConsumCentralProd(wCentralProd, wany, wconsum);
             
      END LOOP;

	   CLOSE cursorCentralProd;

  RETURN functionReturn;
                                                        

END;

/

/
--------------------------------------------------------
--  DDL for Function CONSUMLINIACOMANY
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "CONSUMLINIACOMANY" 	 (wliniaCom VARCHAR2, wany NUMBER)
RETURN taulaConsumAny
IS
   functionReturn  taulaConsumAny :=taulaConsumAny();

   wconsum       NUMBER;
   n             INTEGER := 0;
  
   cursor cursorLiniaCom is
          SELECT consum
          FROM HLINIA_COM
          WHERE codi = NLS_UPPER(TRIM(wliniaCom))
          AND   anyconsum  = wany;

BEGIN
  
	OPEN cursorLiniaCom;
         
      LOOP 
         FETCH cursorLiniaCom
          INTO wconsum;

         EXIT WHEN cursorLiniaCom%NOTFOUND;
         functionReturn.extend;
         n := n + 1;
         functionReturn(n) := filaConsumAny(wliniaCom, wany, wconsum);
         
      END LOOP;

 CLOSE cursorLiniaCom;

 RETURN functionReturn;
                                                       

END consumLiniaComAny;

/

/
--------------------------------------------------------
--  DDL for Function CONSUMMENSUALCOMPTADORCIUTAT
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "CONSUMMENSUALCOMPTADORCIUTAT" (wpoblacio VARCHAR2, wdatainici DATE, wdatafi DATE)
RETURN taulaConsumMensualComptador
IS
   functionReturn  taulaConsumMensualComptador :=taulaConsumMensualComptador();

   wcomptador    VARCHAR2(12);
   wcontracte    VARCHAR2(12);
   wpotencia     NUMBER;
   wconsum       NUMBER;
   wpercentatge  NUMBER;
   wavg          NUMBER;
   n             INTEGER := 0;
  
     
   cursor consumMensualComptador is
       
          SELECT comptador.codi, contracte.codi, contracte.potencia, lectura.consum, lectura.consum
          FROM comptador, contracte, lectura
          WHERE comptador.codi = contracte.comptador
          AND comptador.codi = lectura.comptador
          AND comptador.poblacio = NLS_UPPER(TRIM(wpoblacio))
          AND datalectura BETWEEN wdatainici AND wdatafi
          AND lectura.consum > (SELECT AVG(lectura.consum)*0.8
                        FROM lectura
                        WHERE lectura.datalectura BETWEEN wdatainici AND datafi )
          ORDER BY lectura.consum;

BEGIN
  
   SELECT AVG(consum)*0.8
       INTO wavg
    FROM lectura
    WHERE datalectura BETWEEN wdatainici AND datafi;
  
	OPEN consumMensualComptador;
         
      LOOP 
         FETCH consumMensualComptador
          INTO wcomptador, wcontracte, wpotencia, wconsum, wpercentatge;

         EXIT WHEN consumMensualComptador%NOTFOUND;
         functionReturn.extend;
         n := n + 1;
         functionReturn(n) := filaConsumMensualComptador(wcomptador, wcontracte, wpotencia, wconsum, wpercentatge/wavg);
         
      END LOOP;

 CLOSE consumMensualComptador;

 RETURN functionReturn;
                                                       

END consumMensualComptadorCiutat;

/

/
--------------------------------------------------------
--  DDL for Function LLISTACOMPTADORPERANTIGUITAT
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "LLISTACOMPTADORPERANTIGUITAT" 	 (wanys NUMBER)
RETURN taulaComptadorAntiguitat
IS

   functionReturn  taulaComptadorAntiguitat :=taulaComptadorAntiguitat();

   wcodi         VARCHAR2(12);
   wmodel        VARCHAR2(12);
   wanyfab       NUMBER;
   wanyactual    NUMBER;
   n             INTEGER := 0;
     
   cursor cursorComptadors is
              SELECT COMPTADOR.codi,
                     MODELCMPT.codi,
                     MODELCMPT.anyfab
                FROM COMPTADOR,
                     MODELCMPT
               WHERE COMPTADOR.IDMODEL = MODELCMPT.CODI
               AND   MODELCMPT.anyfab  = wanyactual - wanys ;

BEGIN

  SELECT TO_CHAR(sysdate, 'YYYY')
  INTO wanyactual
  FROM dual ;
      
	OPEN cursorComptadors;
       
     LOOP 
               FETCH cursorComptadors
                INTO wcodi,
                     wmodel,
                     wanyfab;

               EXIT WHEN cursorComptadors%NOTFOUND;
               
               functionReturn.extend;
               n := n + 1;
               functionReturn(n) := filaComptadorAntiguitat(wcodi, wmodel, wanyfab);
      END LOOP;

	CLOSE cursorComptadors;

  RETURN functionReturn;
                                                        

END;

/

/
--------------------------------------------------------
--  DDL for Function PERCENTATGELINIESANY
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "PERCENTATGELINIESANY" 	 (wany NUMBER)
RETURN taulaPercentatgeLiniesAny
IS

   functionReturn  taulaPercentatgeLiniesAny :=taulaPercentatgeLiniesAny(); 

   wtotalmes50       NUMBER;
   wtotallinies      NUMBER;
   n                 INTEGER := 0;   
     
   cursor cursorLinies is
              SELECT count(*)
                FROM HLINIA_COM
               WHERE anyconsum  = wany
               AND consum > capacitatmax*0.5;
   
BEGIN
  
	OPEN cursorLinies;
         
      LOOP 
               FETCH cursorLinies
                INTO wtotalmes50;

               EXIT WHEN cursorLinies%NOTFOUND;
               
               SELECT count(*) into wtotallinies
                FROM HLINIA_COM
               WHERE anyconsum  = wany;
               
                functionReturn.extend;
                n := n + 1;
                functionReturn(n) := filaPercentatgeLiniesAny(wtotalmes50/wtotallinies);
               
      END LOOP;

	   CLOSE cursorLinies;

  RETURN functionReturn;
                                                        

END;

/

/
--------------------------------------------------------
--  DDL for Function PERCENTATGETIPUSLECTURA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "PERCENTATGETIPUSLECTURA" 
(
wdatainici IN DATE , 
wdatafi IN DATE  
) 
RETURN taulaPercentatgeTipusLectura
IS
   functionReturn  taulaPercentatgeTipusLectura:=taulaPercentatgeTipusLectura();

-- definicio de variables
   wTotalP  NUMBER := 0;
   wTotalT  NUMBER := 0;
   wTotal   NUMBER := 0;
   wPerT    NUMBER := 0;
   wPerP    NUMBER := 0;

   
BEGIN
-- Obtenci del total de lectures en el periode indicat
    SELECT COUNT(*) 
    INTO wTotal 
    FROM lectura 
    WHERE TO_CHAR(DATALECTURA, 'DD/MM/YYYY') >= wdatainici
    AND TO_CHAR(DATALECTURA, 'DD/MM/YYYY') <= wdatafi;

-- Obtenci del total de lectures presencials en el periode indicat
    SELECT COUNT(tipus) 
    INTO wTotalP 
    FROM lectura
    WHERE tipus='P'
    AND TO_CHAR(DATALECTURA, 'DD/MM/YYYY') >= wdatainici
    AND TO_CHAR(DATALECTURA, 'DD/MM/YYYY') <= wdatafi;
    
-- Obtenci del total de lectures telematiques en el periode indicat
    SELECT COUNT(tipus) 
    INTO wTotalT 
    FROM lectura
    WHERE tipus='T'
    AND TO_CHAR(DATALECTURA, 'DD/MM/YYYY') >= wdatainici
    AND TO_CHAR(DATALECTURA, 'DD/MM/YYYY') <= wdatafi;

-- Calcul del percentatge de lectures per tipus    
    IF (wTotal > 0) THEN
       wPerP := (wTotalP/wTotal)*100;
       wPerT := (wTotalT/wTotal)*100;
    END IF;

-- Generaci de les dues files amb les dades
    functionReturn.extend;
               functionReturn(1) := filaPercentatgeTipusLectura('PRESENCIAL', wPerP);
               
    functionReturn.extend;
               functionReturn(2) := filaPercentatgeTipusLectura('TELEMATICA', wPerT);
   
  RETURN functionReturn;
                       
END percentatgeTipusLectura;

/

/
--------------------------------------------------------
--  DDL for Function TOPTENCENTRALDISTR
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "TOPTENCENTRALDISTR" 
RETURN taulaCentralDistrEnergia
IS
   functionReturn  taulaCentralDistrEnergia :=taulaCentralDistrEnergia();

 wcentralDistr   VARCHAR2(12);
 wadreca         VARCHAR2(50);
 wpoblacio       VARCHAR2(50);
 wcodipostal     NUMBER;
 wpais           CHAR(2);
 wenergiaemesa  NUMBER;
 wenergiamax     NUMBER;
 n              INTEGER := 0;
  
   cursor cursorCentralDistr is
      SELECT C_CD.centraldistr, CD.ADRECA, CD.POBLACIO, CD.CODIPOSTAL, CD.PAIS, SUM(C.CONSUM), CD.ENERGIAMAX
      FROM COMPTADOR C, COMPTADOR_CENTRALDISTR C_CD,
           CENTRAL_DISTR CD
      WHERE C.codi = C_CD.comptador 
      AND c_cd.centraldistr = CD.CODI
      AND C_CD.activat = 'S'
      AND ROWNUM <= 10
      GROUP BY C_CD.centraldistr, CD.poblacio, CD.ADRECA, 
        CD.POBLACIO, CD.CODIPOSTAL, CD.PAIS, CD.ENERGIAMAX
      ORDER BY SUM(C.CONSUM) DESC;
          
BEGIN
  
	OPEN cursorCentralDistr;
         
      LOOP 
         FETCH cursorCentralDistr
          INTO wcentralDistr, wadreca, wpoblacio, wcodipostal, wpais, wenergiaemesa, wenergiamax;

         EXIT WHEN cursorCentralDistr%NOTFOUND;
         functionReturn.extend;
         n := n + 1;
         functionReturn(n) := filaCentralDistrEnergia(wcentralDistr, wadreca, wpoblacio, 
                                                      wcodipostal, wpais, wenergiaemesa, wenergiamax);
         
      END LOOP;

  CLOSE cursorCentralDistr;

  RETURN functionReturn;
                                                       

END topTenCentralDistr;

/

/
--------------------------------------------------------
--  DDL for Function TOPTENCOMPTADORS
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "TOPTENCOMPTADORS" 
RETURN taulaComptadorConsum
IS
   functionReturn  taulaComptadorConsum :=taulaComptadorConsum();

   wcomptador    VARCHAR2(12);
   wconsum       NUMBER;
   n             INTEGER := 0;
  
   cursor cursorComptadors is
          SELECT codi, consum
          FROM HCOMPTADOR
          WHERE ROWNUM <= 10
          ORDER BY consum DESC;
          
BEGIN
  
	OPEN cursorComptadors;
         
      LOOP 
         FETCH cursorComptadors
          INTO wcomptador, wconsum;

         EXIT WHEN cursorComptadors%NOTFOUND;
         functionReturn.extend;
         n := n + 1;
         functionReturn(n) := filaComptadorConsum(wcomptador, wconsum);
         
      END LOOP;

  CLOSE cursorComptadors;

  RETURN functionReturn;
                                                       

END topTenComptadors;

/

/
--------------------------------------------------------
--  DDL for Function TOPTENLINIACOM

-- NOTA: falta per calcular la carrega i la energia ampliable
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "TOPTENLINIACOM" 
RETURN taulaLiniaComCapacitat
IS
   functionReturn  taulaLiniaComCapacitat :=taulaLiniaComCapacitat();

 wliniacom     VARCHAR2(12);
 wcapacitatmax  NUMBER;
 wcarrega       NUMBER;
 wenergiaampl   NUMBER;
 n              INTEGER := 0;
  
   cursor cursorLiniaCom is
   
      SELECT LC.codi, lc.capacitatmax, lc.capacitatmax, lc.capacitatmax
      FROM LINIA_COM LC, CENTRALPROD_CENTRALDISTR CP
      WHERE LC.codi = CP.linia
      AND CP.activat = 'S'
      AND ROWNUM <= 10
      ORDER BY lc.capacitatmax DESC;
          
BEGIN
  
	OPEN cursorLiniaCom;
         
      LOOP 
         FETCH cursorLiniaCom
          INTO wliniacom, wcapacitatmax, wcarrega, wenergiaampl;

         EXIT WHEN cursorLiniaCom%NOTFOUND;
         functionReturn.extend;
         n := n + 1;
         functionReturn(n) := filaLiniaComCapacitat(wliniacom, wcapacitatmax, wcarrega, wenergiaampl);
         
      END LOOP;

  CLOSE cursorLiniaCom;

  RETURN functionReturn;
                                                       

END topTenLiniaCom;

/

/
