

---------------------------------------------------------------

-- ESTRUCTURA DE DADES PELS PROCEDIMENTS DE CONSULTA
 
---------------------------------------------------------------


---------------------------------------------------------------

-- 1. Tipus de dades necesaris per executar 
-- la funci consumMensualComptadorPerCiutat
 
---------------------------------------------------------------
create or replace
TYPE filaConsumMensualComptador
IS OBJECT 
(
  comptador    VARCHAR2(12),
  contracte    VARCHAR2(12),
  potencia     NUMBER,
  consum       NUMBER,
  percentatge  NUMBER
);
/

create or replace
TYPE   taulaConsumMensualComptador
AS TABLE OF filaConsumMensualComptador
;
/
---------------------------------------------------------------

-- 2. Tipus de dades necesaris per executar 
-- la funci topTenCentralDistr
 
---------------------------------------------------------------

 create or replace
TYPE filaCentralDistrEnergia
IS OBJECT 
(
  centralDistr   VARCHAR2(12),
  adreca         VARCHAR2(50),
  poblacio       VARCHAR2(50),
  codipostal     NUMBER,
  pais           CHAR(2),
  energiaemesa  NUMBER,
  energiamax     NUMBER
 );
/

create or replace
TYPE  taulaCentralDistrEnergia
AS TABLE OF filaCentralDistrEnergia
;

/

---------------------------------------------------------------

-- 3. Tipus de dades necesaris per executar 
-- la funci topTenLiniaCom
 
---------------------------------------------------------------

create or replace
TYPE filaLiniaComCapacitat
IS OBJECT 
(
  liniacom     VARCHAR2(12),
  capacitatmax NUMBER,
  carrega      NUMBER,
  energiaampl  NUMBER
 );
 /

 create or replace
TYPE    taulaLiniaComCapacitat
AS TABLE OF filaLiniaComCapacitat
;

/

---------------------------------------------------------------

-- 4. Tipus de dades necesaris per executar 
-- la funci ClientsComptadorAltaDisp
 
---------------------------------------------------------------

create or replace
TYPE filaClientComptador
IS OBJECT 
(
  dni         VARCHAR2(12),
  comptador   VARCHAR2(12),
  modelcmt    VARCHAR2(12)
);
/

create or replace
TYPE taulaClientComptador
AS TABLE OF filaClientComptador
;
/

---------------------------------------------------------------

-- 5. Tipus de dades necesaris per executar 
-- la funci consumCentralperPeriode
 
---------------------------------------------------------------

create or replace
TYPE filaConsumCentralPeriode 
IS OBJECT 
(
  central      VARCHAR2(12),
  datainici    DATE,
  datafi       DATE,
  consum       NUMBER,
  energia      NUMBER
 );
 
 /
 create or replace
TYPE taulaConsumCentralPeriode
AS TABLE OF filaConsumCentralPeriode
;

/
---------------------------------------------------------------

-- 6. Tipus de dades necesaris per executar 
-- la funci percentatgeTipusLectura
 
---------------------------------------------------------------


create or replace
TYPE filaPercentatgeTipusLectura 
IS OBJECT 
(
  tipus        VARCHAR2(12),
  percentatge  NUMBER(4,2)
 );
/
 
create or replace
TYPE taulaPercentatgeTipusLectura 
AS TABLE OF filaPercentatgeTipusLectura
/

---------------------------------------------------------------

-- 7. Tipus de dades necesaris per executar 
-- la funci llistaComptadorPerAntiguitat
 
---------------------------------------------------------------


create or replace
TYPE filaComptadorAntiguitat 
IS OBJECT 
(
  codi         VARCHAR2(12),
  modelcmt     VARCHAR2(12),
  anyfab       NUMBER
 );
/
 
create or replace
TYPE taulaComptadorAntiguitat
AS TABLE OF filaComptadorAntiguitat
;
/


---------------------------------------------------------------

-- ESTRUCTURA DE DADES PELS PROCEDIMENTS ESTADISTICS
 
---------------------------------------------------------------

---------------------------------------------------------------

-- 1. Tipus de dades necesaris per executar 
-- la funci consumCentralProdAny
 
---------------------------------------------------------------

create or replace
TYPE filaConsumCentralProd 
IS OBJECT 
(
  central      VARCHAR2(12),
  anyconsum    NUMBER,
  consum       NUMBER
 );
 /
create or replace
TYPE taulaConsumCentralProd
AS TABLE OF filaConsumCentralProd
;
/
 
 
---------------------------------------------------------------

-- 2. Tipus de dades necesaris per executar 
-- la funci consumLiniaComAny
 
---------------------------------------------------------------
/

create or replace
TYPE filaConsumAny 
IS OBJECT 
(
  codi         VARCHAR2(12),
  anyconsum    NUMBER,
  consum       NUMBER
 );
 /
 
 
 create or replace
TYPE taulaConsumAny
AS TABLE OF filaConsumAny
;
/
  
---------------------------------------------------------------

-- 3. Tipus de dades necesaris per executar 
-- la funci topTenComptadors
 
---------------------------------------------------------------
create or replace
TYPE filaComptadorConsum
IS OBJECT 
(
  codi         VARCHAR2(12),
  consum       NUMBER
 );
/
create or replace
TYPE taulaComptadorConsum
AS TABLE OF filaComptadorConsum
;

/
  
---------------------------------------------------------------

-- 4. Tipus de dades necesaris per executar 
-- la funci percentatgeLiniesAny
 
---------------------------------------------------------------

create or replace
TYPE filaPercentatgeLiniesAny
IS OBJECT 
(
  percentatge     NUMBER
  );
/
  
create or replace
TYPE  taulaPercentatgeLiniesAny
AS TABLE OF filaPercentatgeLiniesAny
;
/