--------------------------------------------------------
-- Archivo creado  - viernes-junio-08-2012   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Trigger AF_INS_CENTRALPROD
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER AF_INS_CENTRALPROD 
AFTER INSERT ON CENTRAL_PROD 
FOR EACH ROW 

DECLARE 
-- Dades de treball per al procediment
wany HCENTRAL_PROD.anyconsum%TYPE;

BEGIN
  wany := TO_CHAR(:new.dataalta, 'YYYY');
  
  INSERT INTO HCENTRAL_PROD VALUES (:new.CODI,
                                 wany, 
                                 0,
                                 :new.dataalta,
                                 NULL,
                                 NULL,
                                 :new.usuarialta,
                                 NULL,
                                 NULL);
 END;
/

--------------------------------------------------------
--  DDL for Trigger AF_INS_CLIENT
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER AF_INS_CLIENT
AFTER INSERT ON CLIENT 
FOR EACH ROW 
DECLARE 
-- Dades de treball per al procediment
wany HCLIENT.anyconsum%TYPE;
wcount  NUMBER;

BEGIN
  wany := TO_CHAR(:new.dataalta, 'YYYY');
  
  
   SELECT COUNT(*) 
    INTO wcount
     FROM HCLIENT
    WHERE anyconsum = wany ;
 
-- El registre Historic de clients/any no existeix, es dona d'alta    
  IF (wcount = 0) THEN
    INSERT INTO HCLIENT VALUES (wany, 
                                   1,
                                   0,
                                   0,
                                   :new.dataalta,
                                   NULL,
                                   NULL,
                                   :new.usuarialta,
                                   NULL,
                                   NULL);
  ELSE
   UPDATE HCLIENT 
       SET numclients = numclients + 1,
           datamod = :new.dataalta,
           usuarimod = :new.usuarialta
      WHERE anyconsum = wany; 
  
  END IF;
 END;
/
--------------------------------------------------------
--  DDL for Trigger AF_INS_COMPTADOR
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER AF_INS_COMPTADOR
AFTER INSERT ON COMPTADOR 
FOR EACH ROW 
BEGIN
  INSERT INTO HCOMPTADOR VALUES (:new.CODI,
                                 0,
                                 :new.dataalta,
                                 NULL,
                                 NULL,
                                 :new.usuarialta,
                                 NULL,
                                 NULL);
 END;
/
---------------------------------------------------------------------------------------------------------------------------
create or replace
TRIGGER AF_INS_LECTURA
AFTER INSERT ON LECTURA 
FOR EACH ROW
DECLARE 
-- Dades de treball per al procediment
wany HCENTRAL_PROD.anyconsum%TYPE;
wcount  NUMBER;
wconsum NUMBER;
wconsummig NUMBER;
wconsumold NUMBER;
wcomptadors NUMBER;
wnumclients NUMBER;

BEGIN

----------------------------------------------------------

--- HISTORIC CONSUM CENTRAL PRODUCCIO PER ANY ---

----------------------------------------------------------
-- Actualitzem el comptador amb el valor de la ultima lectura i el consum total

     UPDATE HCOMPTADOR
       SET consum = consum + :new.consum,                     
           datamod = :new.dataalta,
           usuarimod = :new.usuarialta
      WHERE codi = NLS_UPPER(TRIM(:new.comptador)); 


-- Obtenim el any de les dades de la lectura

  wany := TO_CHAR(:new.datalectura, 'YYYY');
----------------------------------------------------------

--- HISTORIC CONSUM CENTRAL PRODUCCIO PER ANY ---

----------------------------------------------------------

  -- Busqueda del registre de la central/any

  SELECT COUNT(*) 
    INTO wcount
     FROM HCENTRAL_PROD
    WHERE codi = NLS_UPPER(TRIM(:new.centralprod))
    AND anyconsum = wany ;

-- El registre central/any no existeix, es dona d'alta    
   IF (wcount = 0) THEN
     INSERT INTO HCENTRAL_PROD VALUES (NLS_UPPER(TRIM(:new.centralprod)),
                                       wany,
                                       :new.consum,
                                       :new.dataalta,
                                       NULL,
                                       NULL,
                                       :new.usuarialta,
                                       NULL,
                                       NULL);
   ELSE     
-- Modificaci del valor de consum per la central/any  
      UPDATE HCENTRAL_PROD 
       SET consum = consum + :new.consum,
           datamod = :new.dataalta,
           usuarimod = :new.usuarialta
      WHERE codi = NLS_UPPER(TRIM(:new.centralprod))
      AND anyconsum = wany;                                  
   END IF;


----------------------------------------------------------

--- HISTORIC CONSUM CLIENTS PER ANY ---

----------------------------------------------------------

-- Busqueda del total de clients

  SELECT  COUNT(*)  
     INTO wnumclients
     FROM CLIENT;
    
-- Busqueda del registre de la central/any

  SELECT COUNT(*) 
    INTO wcount
     FROM HCLIENT
    WHERE anyconsum = wany ;


  

  IF (wcount = 0) THEN
     INSERT INTO HCLIENT VALUES (wany,
                                 wnumclients,
                                 :new.consum,
                                 :new.consum/wnumclients,
                                 :new.dataalta,
                                 NULL,
                                 NULL,
                                 :new.usuarialta,
                                 NULL,
                                 NULL);
   ELSE     
      
-- Modificaci del valor de consum i consum mig de clients/any  
      UPDATE HCLIENT 
       SET numclients = wnumclients,
           consumtotal = consumtotal + :new.consum,
           consummig = (consumtotal + :new.consum) / wnumclients,
           datamod = :new.dataalta,
           usuarimod = :new.usuarialta
      WHERE anyconsum = wany;

  END IF;

----------------------------------------------------------

--- HISTORIC CONSUM LINIA COMUNICACIO PER ANY ---

----------------------------------------------------------

  wany := TO_CHAR(:new.datalectura, 'YYYY');
  wcomptadors := 0;
  
-- Lectura del nombre de comptadors que fan servir la linia per calcular el consum mig

      SELECT COUNT(comptador)
        INTO wcomptadors
        FROM comptador_centraldistr c1,
        centralprod_centraldistr c2
      WHERE c1.centraldistr = c2.centraldistr
      AND c1.activat = 'S'
      AND c2.activat = 'S'
      AND c2.linia = :new.liniacom;  
 
-- Busqueda del registre de la linia/any

  SELECT COUNT(*) 
    INTO wcount
     FROM HLINIA_COM
    WHERE codi = NLS_UPPER(TRIM(:new.liniacom))
    AND anyconsum = wany ;

-- El registre lnia /any no existeix, es dona d'alta    
   IF (wcount = 0) THEN

-- Calcul de les noves dades, consum anual i consum mig segons els comptadors que utilitzen la linie     
     wconsum := :new.consum;
     wconsummig := :new.consum / wcomptadors;
     
     INSERT INTO HLINIA_COM VALUES (NLS_UPPER(TRIM(:new.liniacom)),
                                       wany,
                                       wconsum,
                                       wconsummig,
                                       0,
                                       :new.dataalta,
                                       NULL,
                                       NULL,
                                       :new.usuarialta,
                                       NULL,
                                       NULL);
   ELSE     

-- Calcul de les noves dades, consum anual i consum mig segons els comptadors que utilitzen la linie

-- Modificaci del valor de consum per la linia/any  
      UPDATE HLINIA_COM 
        SET consum = consum + :new.consum,
           valormigconsum = (consum + :new.consum)/wcomptadors,
           datamod = :new.dataalta,
           usuarimod = :new.usuarialta
      WHERE codi = NLS_UPPER(TRIM(:new.liniacom))
      AND anyconsum = wany;                                  
   END IF;

-- Control d'excepcions
   EXCEPTION 
     WHEN OTHERS THEN
       ROLLBACK;

END;
/


