DECLARE resultat varchar2(256);
BEGIN


-------------------------------------------------------------------------
-- 
-- PROCEDIMENT DE TEST DELS PROCEDIMENTS DE ALTA/BAIXA/MODIFICACIO
-- 
-------------------------------------------------------------------------


-------------------------------------------------------------------------
--
-- 1. TEST DELS PROCEDIMENTS DE LA TAULA PAIS
--
-------------------------------------------------------------------------


-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula PAIS
-------------------------------------------------------------------------

-- Parametres d'entrada nuls

altaPais('IE',null,'TEST', resultat);

-- Pais ja existent
altaPais('AT','Austria','TEST', resultat);


-- Alta correcta
altaPais('IE','Irlandaa','TEST', resultat);

altaPais('XX','per esborrar','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de modificaci de la taula PAIS
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaPais('IE',null,'TEST', resultat);

-- Pais no existent
modificaPais('II','Irlanda','TEST', resultat);

-- Modificaci correcta
modificaPais('IE','Irlanda','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula PAIS
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaPais(null,'TEST', resultat);

-- Pais no existent
baixaPais('II','TEST', resultat);

-- Baixa correcte
baixaPais('XX','TEST', resultat);

-------------------------------------------------------------------------
--
-- 2. TEST DELS PROCEDIMENTS DE LA TAULA MODELCMPT
--
-------------------------------------------------------------------------

-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula MODELCMPT
-------------------------------------------------------------------------

-- Parametres d'entrada nuls

altaModel(null,'5000',null,'2010','TEST',resultat);

-- Model ja existent
altaModel('LM0000008000','8000','LUMIX','2000','TEST',resultat);

-- Alta correcta
altaModel('LM0000006000','6000','LUMIX','2001','TEST',resultat);

-- Alta correcta per donar de baixa 
altaModel('XX0000006000','8000','ESBORRAR','2000','TEST',resultat);


-------------------------------------------------------------------------
-- Test del procediment de modificacio de la taula MODELCMPT
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaModel('LM0000008000',null,'LUMIX',null,'TEST',resultat);

-- Model no existent
modificaModel('LM0000001000','8000','LUMIX','2001','TEST',resultat);

-- Modificaci correcta
modificaModel('LM0000006000','6000','LUMIX','2011','TEST',resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula MODELCMPT
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaModel(null,'TEST', resultat);

-- Model no existent
baixaModel('XX0000006666','TEST', resultat);

-- Baixa correcta
baixaModel('XX0000006000','TEST', resultat);

-------------------------------------------------------------------------
--
-- 3. TEST DELS PROCEDIMENTS DE LA TAULA COMPTADOR
--
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaComptador('EB4000000222','EB0000003000',null,'TARRAGONA','43004','ES','0','TEST', resultat);

-- Comptador ja existent
altaComptador('EB4000000002','EB0000005000','C/ DEL ARCO, 24','TARRAGONA','43004','ES','0','TEST', resultat);

-- Error de restricci d'integritat, el Pais no existeix
altaComptador('BB6000000002','LM0000006000','AV. JETTE, 35','GANSHOREN','1083','TE','0','TEST', resultat);

-- Alta correcta
altaComptador('BB6000000002','LM0000006000','AV. JETTE, 35','GANSHOREN','1083','BE','0','TEST', resultat);


-------------------------------------------------------------------------
-- Test del procediment de modificaci de la taula COMPTADOR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaComptador('EB4300000001',null,'C/ LORCA, 10',null,'41001','ES','0','TEST', resultat);

-- Comptador no existent
modificaComptador('BB6000000222','LM0000006000','AV. JETTE, 355','GANSHOREN','1083','DK','0','TEST', resultat);

-- Modificaci correcta
modificaComptador('BB6000000002','LM0000006000','AV. JETTE, 355','GANSHOREN','1083','DK','0','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula COMPTADOR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaComptador('EB4000000003',null, resultat);

-- Comptador no existent
baixaComptador('EB4000000222','TEST', resultat);

-- Baixa correcta
baixaComptador('BB6000000002','TEST', resultat);


-------------------------------------------------------------------------
--
-- 4. TEST DELS PROCEDIMENTS DE LA TAULA CLIENT
--
-------------------------------------------------------------------------


-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula CLIENT
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaClient('41237581A',null,null,'BADAL','VIDAL','C/ DEL ECUADOR 186','GIRONA','17001','ES','972-3278700','mbadalvidal@yahoo.com','TEST', resultat);

-- Client ja existent
altaClient('40175815P','F','MIQUEL','CARMONA','VIDAL','C/ DE LA MUNTANYA 26','GIRONA','17001','ES','972-4378700','mcarmonavidal@gmail.com','TEST', resultat);

-- Error de restricci d'integritat, 'Z' no es valor valid per el tipus
altaClient('41237581A','Z','BADAL SA.', null,null,'C/ DEL ECUADOR 186','GIRONA','17001','ES','972-3278700','mbadalvidal@yahoo.com','TEST', resultat);

-- Alta correcta
altaClient('41237581A','J','BADAL SA.', null,null,'C/ DEL ECUADOR 186','GIRONA','17001','ES','972-3278700','mbadalvidal@yahoo.com','TEST', resultat);


-------------------------------------------------------------------------
-- Test del procediment de modificacio de la taula CLIENT
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaClient('41237581A','J','BADAL SA.', null,null,null,'GIRONA','17001','ES','972-3278700','mbadalvidal@yahoo.com','TEST', resultat);

-- Client no existent
modificaClient('11111111A','J','BADAL SA.', null,null,'C/ DEL ECUADOR 186','GIRONA','17001','ES','972-3278700','mbadalvidal@yahoo.com','TEST', resultat);

-- Error de restricci d'integritat, el pais no existeix
modificaClient('41237581A','J','BADAL SA.', null,null,'C/ DEL ECUADOR 186','GIRONA','17001','EE','972-3278700','badalsa@yahoo.com','TEST', resultat);

-- Modificacio correcta
modificaClient('41237581A','J','BADAL SA.', null,null,'C/ DEL ECUADOR 186','GIRONA','17001','ES','972-3278700','badalsa@yahoo.com','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula CLIENT
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaClient('41237581A',null, resultat);

-- Client no existent
baixaClient('11111111A','TEST', resultat);

-- Baixa correcta
baixaClient('41237581A','TEST', resultat);



-------------------------------------------------------------------------
--
-- 5. TEST DELS PROCEDIMENTS DE LA TAULA CONTRACTE
--
-------------------------------------------------------------------------


-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula CONTRACTE
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaContracte('CT010',null,null,'31589815K','3000','0,7','TEST', resultat);

-- Contracte ja existent
altaContracte('CT001',to_date('01/01/2011','DD/MM/YYYY'),'EB6000000004','31589815K','3000','0,7','TEST', resultat);

-- Error de restricci d'integritat, el client no existeix
altaContracte('CT010',to_date('01/01/2011','DD/MM/YYYY'),'EB6000000004','1111111156K','3000','0,7','TEST', resultat);

-- Alta correcta 
altaContracte('CT010',to_date('01/01/2011','DD/MM/YYYY'),'EB6000000004','31589815K','3000','0,7','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de modificacio de la taula CONTRACTE
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaContracte('CT010',to_date('01/01/2011','DD/MM/YYYY'),'EB6000000004','31589815K',null,null,'TEST', resultat);

-- Contracte no existent
modificaContracte('CT021',to_date('01/01/2011','DD/MM/YYYY'),'EB6000000004','31589815K','4000','0,7','TEST', resultat);

-- Modificacio correcta
modificaContracte('CT010',to_date('01/01/2011','DD/MM/YYYY'),'EB6000000004','31589815K','4000','0,7','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula CONTRACTE
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaContracte('CT010',null,'TEST', resultat);

-- Contracte no existent
baixaContracte('CT021',to_date('31/05/2012','DD/MM/YYYY'),'TEST', resultat);

-- Baixa correcta
baixaContracte('CT010',to_date('31/05/2012','DD/MM/YYYY'),'TEST', resultat);

-------------------------------------------------------------------------
--
-- 6. TEST DELS PROCEDIMENTS DE LA TAULA LINIA_COM
--
-------------------------------------------------------------------------

-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula LINIA_COM
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaLiniaCom('ESL0020',null,'TEST', resultat);

-- Linia ja existent
altaLiniaCom('ESL0001',400000,'TEST', resultat);

-- Alta correcta
altaLiniaCom('ESL0020',400000,'TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de modificacio de la taula LINIA_COM
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaLiniaCom('ESL0020',null,null, resultat);

-- Linia no existent
modificaLiniaCom('ESL0222',null,null, resultat);

-- Modificacio correcta
modificaLiniaCom('ESL0020',500000,'TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula LINIA_COM
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaLiniaCom('ESL0020',null, resultat);

-- Linia no existent
baixaLiniaCom('ESL0222','TEST', resultat);

-- Baixa correcta
baixaLiniaCom('ESL0020','TEST', resultat);


-------------------------------------------------------------------------
--
-- 7. TEST DELS PROCEDIMENTS DE LA TAULA CENTRAL_DISTR
--
-------------------------------------------------------------------------

-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula CENTRAL_DISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaCentralDistr('ESD011',null, null,'43005','ES',10000,'TEST', resultat);

-- Central distribucio ja existent
altaCentralDistr('ESD001','AV. TOLSTOI, 100','TARRAGONA','43005','ES',10000,'TEST', resultat);

-- Alta correcta
altaCentralDistr('ESD011','AV. TOLSTOI, 100','TARRAGONA','43005','ES',10000,'TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de modificacio de la taula CENTRAL_DISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaCentralDistr('ESD011',null, null,'43005','ES',10000,'TEST', resultat);

-- Central distribucio no existent
modificaCentralDistr('ESD111','AV. TOLSTOI, 100','TARRAGONA','43005','ES',10000,'TEST', resultat);

-- Error de restricci d'integritat, el pais no existeix
modificaCentralDistr('ESD011','AV. TOLSTOI, 150','TARRAGONA','43005','SS',10000,'TEST', resultat);

-- Modifica correcta
modificaCentralDistr('ESD011','AV. TOLSTOI, 150','TARRAGONA','43005','ES',10000,'TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula CENTRAL_DISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaCentralDistr('ESD011',null, resultat);

-- Central distribucio no existent
baixaCentralDistr('ESD111','TEST', resultat);

-- Baixa correcta
baixaCentralDistr('ESD011','TEST', resultat);



-------------------------------------------------------------------------
--
-- 8. TEST DELS PROCEDIMENTS DE LA TAULA CENTRAL_PROD
--
-------------------------------------------------------------------------

-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula CENTRAL_PROD
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaCentralProd('ES009',null, 'SANT BOI LLOBREGAT','08325','ES','T',null,null,'1000',null,null,'TEST', resultat);

-- Central produccio ja existent
altaCentralProd('ES001','POLIGON 1, N-2, KM. 224','SANT BOI LLOBREGAT','08325','ES','T',null,null,'1000',null,null,'TEST', resultat);

-- Error de restricci d'integritat, el pais no existeix
altaCentralProd('ES009','POLIGON 2, N-2, KM. 124','SANT BOI LLOBREGAT','08325','ZZ','T',null,null,'1000',null,null,'TEST', resultat);

-- Alta correcta
altaCentralProd('ES009','POLIGON 2, N-2, KM. 124','SANT BOI LLOBREGAT','08325','ES','T',null,null,'1000',null,null,'TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de modificacio de la taula CENTRAL_PROD
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaCentralProd('ES099',null,null,null,'ES','T',null,null,1000,null,null,'TEST', resultat);

-- Central produccio no existent
modificaCentralProd('ES099','POLIGON 22, N-2, KM. 124','SANT BOI LLOBREGAT','08325','ES','T',null,null,'1000',null,null,'TEST', resultat);

-- Error de restricci d'integritat, el tipus de central no es correcte
modificaCentralProd('ES009','POLIGON 22, N-2, KM. 124','SANT BOI LLOBREGAT','08325','ES','M',null,null,'1000',null,null,'TEST', resultat);

-- Modificacio correcta
modificaCentralProd('ES009','POLIGON 22, N-2, KM. 124','SANT BOI LLOBREGAT','08325','ES','T',null,null,'1000',null,null,'TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula CENTRAL_PROD
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaCentralProd('ES009',null,resultat);

-- Central produccio no existent
baixaCentralProd('ES0999','TEST',resultat);

-- Baixa correcta
baixaCentralProd('ES009','TEST',resultat);


-------------------------------------------------------------------------
--
-- 9. TEST DELS PROCEDIMENTS DE LA TAULA COMPTADOR_CENTRALDISTR
--
-------------------------------------------------------------------------

-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula COMPTADOR_CENTRALDISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaComptadorCentralDistr('SB5000000001',null,'S','TEST', resultat);

-- Connexio comptador-central distribuci ja existent
altaComptadorCentralDistr('SB5000000001','ESD003','S','TEST', resultat);

-- Alta connexi correcta
altaComptadorCentralDistr('SB5000000001','ESD010','N','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de modificacio de la taula COMPTADOR_CENTRALDISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaComptadorCentralDistr('BB6000000002',null,'S','TEST', resultat);

-- Connexio comptador-central distribuci no existent
modificaComptadorCentralDistr('BB6000000002','ESD003','S','TEST', resultat);

-- Error de restricci d'integritat, el valor del camp activat no es valid
modificaComptadorCentralDistr('BB6000000002','ESD010','Y','TEST', resultat);

-- Modificacio correcta
modificaComptadorCentralDistr('BB6000000002','ESD010','S','TEST', resultat);


-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula COMPTADOR_CENTRALDISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaComptadorCentralDistr('BB6000000002',null,'TEST', resultat);

-- Connexio comptador-central distribuci no existent
baixaComptadorCentralDistr('BB6000000002','ESD003','TEST', resultat);

-- Baixa correcta
baixaComptadorCentralDistr('BB6000000002','ESD010','TEST', resultat);

-------------------------------------------------------------------------
--
-- 6. TEST DELS PROCEDIMENTS DE LA TAULA CENTRALPROD_CENTRALDISTR
--
-------------------------------------------------------------------------

-------------------------------------------------------------------------
-- Test del procediment d'alta de la taula CENTRALPROD_CENTRALDISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaCentralProdCentralDistr('ES001','ESL0001','ESD003',null,'TEST', resultat);

-- Connexio central produccio-linia-central distribuci ja existent
altaCentralProdCentralDistr('ES001','ESL0001','ESD003','N','TEST', resultat);

-- Error de restricci d'integritat, la central de distribuci no existeix
altaCentralProdCentralDistr('ES003','ESL0003','ESD088','N','TEST', resultat);

-- Alta correcta
altaCentralProdCentralDistr('ES007','ESL0007','ESD003','N','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de modificacio de la taula CENTRALPROD_CENTRALDISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
modificaCtralProdCtralDistr('ES001','ESL0001','ESD003',null,'TEST', resultat);

-- Connexio central produccio-linia-central distribuci no existent
modificaCtralProdCtralDistr('ES001','ESL0001','ESD008','N','TEST', resultat);

-- Error de restricci d'integritat, valor del camp actiu no es valid
modificaCtralProdCtralDistr('ES001','ESL0001','ESD003','Y','TEST', resultat);

-- Modificacio correcta
modificaCtralProdCtralDistr('ES008','ESL0018','ESD009','S','TEST', resultat);

-------------------------------------------------------------------------
-- Test del procediment de baixa de la taula CENTRALPROD_CENTRALDISTR
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
baixaCentralProdCentralDistr('ES001','ESL0001',null,null, resultat);

-- Connexio central produccio-linia-central distribuci no existent
baixaCentralProdCentralDistr('ES001','ESL0001','ES008','TEST', resultat);

-- Baixa correcta
baixaCentralProdCentralDistr('ES004','ESL0014','ESD006','TEST', resultat);


-------------------------------------------------------------------------
--
-- 7. TEST DEL PROCEDIMENT DE LA TAULA LECTURA
--
-------------------------------------------------------------------------

-- Parametres d'entrada nuls
altaLectura('01/01/2012','EB4000000003',null,null,'INIT', resultat);

-- Error de restricci d'integritat, valor del camp actiu no es valid
altaLectura('01/01/2012','XXXX00000003',640,'T','INIT', resultat);

-- Lectura ja existent pel comptador/data
altaLectura('01/12/2011','EB4000000003',540,'T','INIT', resultat);

-- Alta correcta
altaLectura('01/01/2012','EB4000000003',640,'T','INIT', resultat);

END;
