---------------------------------------------
-- EXECUCIO CONSULTAS
---------------------------------------------

-- 1. Llistat de comptadors d'una ciutat que superan el 80% del consum
select * from table (consumMensualComptadorCiutat ('BARCELONA', '01/06/2011', '30/06/2011'));
/
-- 2. Llistat de centrals de distribuci que distribueixen mes energia
select * from table (topTenCentralDistr ());
/
-- 3. Llistat de les 10 lnies de comunicaci mes carregades
select * from table (topTenLiniaCom());
/
-- 4. Llistat de clients disposant de comptadors amb servei en alta disponibilitat
select * from table (ClientsComptadorAltaDisp ());
/
-- 5. Consum i energia produda duna central en un perode de temps
select * from table (consumCentralperPeriode ('ES002','01/02/2011','31/12/2011'));
/
-- 6. Percentatge de lectures de comptadors
select * from table (percentatgeTipusLectura('01/01/2011','31/12/2011' ));
/
-- 7. Llistat de comptadors per antiguitat
select * from table (llistaComptadorPerAntiguitat(5));
/
---------------------------------------------------
-- CONSULTES ESTADISTIC DE LES TAULES DEL HISTORIC
---------------------------------------------------

-- 1a. Consum anual dels comptadors connectats a una central de producci, obtingut amb funci
select * from table (consumCentralProdAny ('ES002',2011));
/
-- 1b. Consum anual dels comptadors connectats a una central de producci, obtingut amb consulta
SELECT codi, consum
          FROM HCENTRAL_PROD
          WHERE   anyconsum  = 2011;
/

-- 2a. Valor mig energia consumida per lnia de comunicaci en un any, obtingut amb funci
select * from table (consumLiniaComAny ('ESL0002', 2011));
/
-- 2b. Valor mig energia consumida per lnia de comunicaci en un any, obtingut amb consulta
select codi, valormigconsum, anyconsum 
from HLINIA_COM
where anyconsum = 2011;
/

-- 3. Lnia de comunicaci mes carregada a nivell denergia consumida
select codi, consum, anyconsum 
from HLINIA_COM
where consum = (select max(consum) 
from hlinia_com
where anyconsum = 2011);
/

-- 4. Percentatge de lnies que superen el 50% denergia consumida en un any
select * from table (percentatgeLiniesAny (2011));
/
-- 5. Nombre de centrals de producci que generen menys del 30% de producci
select count(*) from hcentral_prod
where consum < 
(select sum(consum)*0.3 
from hcentral_prod
where anyconsum = 2011);
/

-- 6a. Comptadors que histricament han tinguin mes consum, obtingut amb funci

select * from table (topTenComptadors ());
/

-- 6b. Comptadors que histricament han tinguin mes consum, obtingut amb consulta
SELECT codi, consum
          FROM HCOMPTADOR
          WHERE ROWNUM <= 10
          ORDER BY consum desc, codi;
/
-- 7. Consum mig de tots els clients en un any concret

SELECT CONSUMMIG FROM HCLIENT
WHERE ANYCONSUM = 2012;
/
